#!/bin/bash

git config --global credential.helper store


grep -qF '* soft nofile 102400' /etc/security/limits.conf  || echo '* soft nofile 102400' >>  /etc/security/limits.conf  
grep -qF '* hard nofile 102400' /etc/security/limits.conf  || echo '* hard nofile 102400' >>  /etc/security/limits.conf   

if [ ! -f /etc/sysctl.conf.bak ]; then
    mv /etc/sysctl.conf /etc/sysctl.conf.bak 
    cp ./sysctl.conf /etc/sysctl.conf  
fi
modprobe nf_conntrack 
/sbin/sysctl -p

grep -qF 'ulimit -HSn 102400' /etc/profile  || echo 'ulimit -HSn 102400' >>  /etc/profile 
echo 1024 >/proc/sys/net/core/somaxconn
echo never > /sys/kernel/mm/transparent_hugepage/enabled


if [[ ! -f "/etc/rc.local" ]]
then
cat <<EOF >/etc/rc.local
#!/bin/sh -e
#
# rc.local
#
# This script is executed at the end of each multiuser runlevel.
# Make sure that the script will "exit 0" on success or any other
# value on error.
#
# In order to enable or disable this script just change the execution
# bits.
#
# By default this script does nothing.

exit 0
EOF
chmod +x /etc/rc.local
fi

sed -i '/exit 0/d' /etc/rc.local && echo 'exit 0' >>  /etc/rc.local
grep -qF 'modprobe nf_conntrack ' /etc/rc.local || sed -i 's/exit 0/modprobe nf_conntrack\nexit 0/g' /etc/rc.local
grep -qF 'ulimit -HSn 102400' /etc/rc.local || sed -i 's/exit 0/ulimit -HSn 102400\nexit 0/g' /etc/rc.local
grep -qF '/sys/kernel/mm/transparent_hugepage/enabled' /etc/rc.local || sed -i 's/exit 0/echo never > \/sys\/kernel\/mm\/transparent_hugepage\/enabled\nexit 0/g' /etc/rc.local
grep -qF '/proc/sys/net/core/somaxconn' /etc/rc.local || sed -i 's/exit 0/echo 1024 >\/proc\/sys\/net\/core\/somaxconn\nexit 0/g' /etc/rc.local

source /etc/profile
ulimit -n 102400

sed -i 's/Port 22/#Port 22\n/g' /etc/ssh/sshd_config
sed -i 's/#Port 22/Port 22\nPort 17385\n/g' /etc/ssh/sshd_config
sed -i 's/GSSAPIAuthentication yes/GSSAPIAuthentication no/g' /etc/ssh/sshd_config
sed -i 's/GSSAPICleanupCredentials yes/GSSAPICleanupCredentials no/g' /etc/ssh/sshd_config
sed -i 's/UsePAM no/UsePAM yes\n/g' /etc/ssh/sshd_config
sed -i 's/#UseDNS no/UseDNS no\n/g' /etc/ssh/sshd_config
sed -i 's/#TCPKeepAlive yes/TCPKeepAlive yes/g' /etc/ssh/sshd_config
sed -i '/#ClientAliveInterval/cClientAliveInterval 60' /etc/ssh/sshd_config
sed -i '/#ClientAliveCountMax/cClientAliveCountMax 60' /etc/ssh/sshd_config

day=$(date +%d)
if [ $day -lt 29 ]; then
    sed -i '/^;MonthRotate/c\MonthRotate 1' /etc/vnstat.conf
    sed -i "/^MonthRotate /c\MonthRotate $day" /etc/vnstat.conf
fi

systemctl restart sshd
systemctl enable vnstat
systemctl start vnstat

ln -sf /usr/share/zoneinfo/Asia/Shanghai /etc/localtime
localedef -c -f UTF-8 -i en_US en_US.UTF8
ulimit -Sa | grep "open files"

mkdir /root/.ssh

cp ./welcome /root/.welcome

#sh -c "$(curl -fsSL https://list.downsoft.cn/Linux/zsh/oh-my-zsh-init.sh)"
tar zxvf oh-my-zsh.tar.gz  -C /root/
chown -R root:root /root/.oh-my-zsh
chmod +x install-oh-my-zsh.sh
./install-oh-my-zsh.sh

mkdir -p /root/.oh-my-zsh/custom/plugins/
cp ./zsh-autosuggestions.tar.gz /root/zsh-autosuggestions.tar.gz
tar zxvf /root/zsh-autosuggestions.tar.gz  -C /root/.oh-my-zsh/custom/plugins/
chmod -R 644 /root/.oh-my-zsh/custom/plugins/zsh-autosuggestions
chown -R root:root /root/.oh-my-zsh/

cp ./zshrc /root/.zshrc
cp ./vimrc /root/.vimrc
mv /root/.oh-my-zsh/lib/misc.zsh /root/.oh-my-zsh/lib/misc.zsh.bak
cp ./misc.zsh /root/.oh-my-zsh/lib/misc.zsh
#env zsh -l
#source /root/.zshrc

exit 0
